/*Tento program byl vytvořen v IDE C write'n'run 1.1.*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>//vpodstatě jen kvůli zaokrouhlování
typedef long unsigned int cislo;
FILE *sou;
time_t adt;//aktuální datum /  čas
struct tm *dtp;//datum / čas pointer

cislo instro()
{cislo moc;
 adt=time(NULL);
 dtp=localtime(&adt);

 sou=fopen("GEN.TXT","w");
 printf("Vítejte v algoritmu na generování velmi velkých mocnin čísla 2\n");
 printf(">>>>>>>>>>>>>>>>>>>>> made by m@rtlin >>>>> 3.7 - 3.8. 2011 >>\n\n");
 printf("Program ze zadaného exponentu vyčíslí hodnotu čísla 2 na tento exponent, které následně uloží v binárním, dekadickém i hexadecimálním tvaru do patřičných souborů (BIN.TXT, DEC.TXT a HEX.TXT) a sepíše o generování jednoduchý protokol GEN.TXT.\n\n");
printf("POZOR! Zvažte generování velmi velkých čísel v závislosti na výkonu Vašeho počítače. Generování by mohlo trvat velmi dlouho (desítky minut), vyžaduje poměrně velké množství paměti (až v řádech MB) a výsledné soubory s vygenerovanými čísly mohou na disku zabírat stovky MB až jednotky GB!\n\n");
 printf("Zadejte exponent čísla 2 (0 až 4 294 967 296): ");
 scanf("%lu",&moc);

  fprintf(sou,"Protokol o generování čísla 2^%lu z %u. %u. %u:\n",moc,dtp->tm_mday,(dtp->tm_mon+1),(dtp->tm_year+1900));
 fclose(sou);
 return moc;}
////////////////////////////////////////////////////////////////////////////
bin(cislo mc)
{
 cislo a,b;
 time_t kon;//čas konce generování

 adt=time(NULL);
 dtp=localtime(&adt);
 printf("------------------------------------------------");
 printf("\n\fGenerování BINÁRNÍHO čísla 2^%lu:\n",mc);
 printf(" Začátek: %u:%02u:%02u\n   Načítání souboru...",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);
 printf("\n   Generování čísla...");
 sou=fopen("BIN.TXT","w");

 printf("\n   Ukládání souboru...");
/*algoritmus*/
 fputs("1",sou);
 for (a=mc;(a%4)!=0;a--) fputs("0",sou); //zanedbatelný čas
 b=a/4; //z predchozho radku vyplyva, ze b%4=0, takze a/4 je cele cislo
 for (a=1;a<=b;a++) fputs(" 0000",sou);
/*alogritmus*/
 fclose(sou);

 kon=time(NULL);
 dtp=localtime(&kon);
 printf("\n\a Konec:   %u:%02u:%02u\n",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);
 
 adt=difftime(kon,adt);
 dtp=localtime(&adt);

 sou=fopen("GEN.TXT","a");
  fprintf(sou,"BINÁRNÍ:       doba generování: %2u min %2u sec, velikost čísla: %lu cifer\n",dtp->tm_min,dtp->tm_sec,++mc);
 fclose(sou);
 printf("\nGenerování BINÁRNÍHO čísla úspěšně dokončeno.\n");
}
////////////////////////////////////////////////////////////////////////////
hex(cislo mc)
{
 cislo a,b;
 unsigned int c;
 ldiv_t cm;
 time_t kon;//čas konce generování

 adt=time(NULL);
 dtp=localtime(&adt);
 printf("------------------------------------------------");
 printf("\n\fGenerování HEXADECIMÁLNÍHO čísla 2^%lu:\n",mc);
 printf(" Začátek: %u:%02u:%02u\n   Načítání souboru...",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);
 printf("\n   Generování čísla...");
 sou=fopen("HEX.TXT","w");

 printf("\n   Ukládání souboru...");
/*algoritmus*/
 cm=ldiv(mc,8);
 a=cm.rem;//zbytek co nevešel do kombinace
 b=cm.quot;//počet kombinací ' 00'
 
 cm=ldiv(a,4);
 if (cm.quot>=1) { 
  c=1;
  for (a=1;a<=cm.rem;a++) c*=2;//alternativa k pow
  fprintf(sou,"%u0",c);
  } else {
   c=1;
  for (a=1;a<=cm.rem;a++) c*=2;//alternativa k pow
  fprintf(sou,"%u",c);
 }

 for (a=1;a<=b;a++) fputs(" 00",sou);
/*alogritmus*/
 fclose(sou);

 kon=time(NULL);
 dtp=localtime(&kon);
 printf("\n\a Konec:   %u:%02u:%02u\n",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);

 adt=difftime(kon,adt);
 dtp=localtime(&adt);

 sou=fopen("GEN.TXT","a");
  fprintf(sou,"HEXADECIMÁLNÍ: doba generování: %2u min %2u sec, velikost čísla: %lu cifer\n",dtp->tm_min,dtp->tm_sec,2*b+(++cm.quot));
 fclose(sou);
 printf("\nGenerování HEXADECIMÁLNÍHO čísla úspěšně dokončeno.\n");
}
////////////////////////////////////////////////////////////
dec(cislo mc)
{
 cislo a,b;//iterátory cyklů
 cislo pameti=1000,polozek=1,carry,*pntr;
 time_t kon;//čas konce generování

 adt=time(NULL);
 dtp=localtime(&adt);
 printf("------------------------------------------------");
 printf("\n\fGenerování DEKADICKÉHO čísla 2^%lu:\n",mc);
 printf(" Začátek: %u:%02u:%02u\n   Načítání souboru...",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);
 printf("\n   Generování čísla...");
 sou=fopen("DEC.TXT","w");

 printf("\n   Ukládání souboru...");
/*algoritmus*/
// samotné generování
        pntr=malloc(pameti*sizeof(cislo));
        if (!pntr) return;
        pntr[0]=1;
        pntr[1]=0;

        for (a=1;a<=mc;a++) {
                carry=0;
                for (b=0;b<polozek;b++) {
                        pntr[b]*=2;
                        pntr[b]+=carry;
                        if (pntr[b]>999999) {
                                pntr[b]%=1000000;
                                carry=1;
                        } else  carry=0;
                }
              	if (carry) {
                        if (polozek==pameti) {
                                pameti+=2000;
                                pntr=realloc(pntr,(pameti*sizeof(cislo)));
                                if (!pntr) return;
                        }
                        pntr[polozek]=1;
                        polozek++;
                }
        }
//výpis do souboru 
	if (pntr[polozek-1]>1000) 	fprintf(sou,"%lu %03lu",pntr[polozek-1]/1000,pntr[polozek-1]%1000);
		else 			fprintf(sou,"%lu",pntr[polozek-1]);
	if (polozek>2) for (a=(polozek-2);a>0;a--) fprintf(sou," %03lu %03lu",pntr[a]/1000,pntr[a]%1000);
	if (polozek>1) fprintf(sou," %03lu %03lu",pntr[0]/1000,pntr[0]%1000);
//určení počtu cifer	
	b=--polozek;
	polozek*=6;
	for (a=1;pntr[b]>=a;a*=10) polozek++;	
	free(pntr);
/*alogritmus*/
 fclose(sou);

 kon=time(NULL);
 dtp=localtime(&kon);
 printf("\n\a Konec:   %u:%02u:%02u\n",dtp->tm_hour,dtp->tm_min,dtp->tm_sec);

 adt=difftime(kon,adt);
 dtp=localtime(&adt);

 sou=fopen("GEN.TXT","a");
  fprintf(sou,"DEKADICKÉ:     doba generování: %2u min %2u sec, velikost čísla: %lu cifer\n",dtp->tm_min,dtp->tm_sec,polozek);
 fclose(sou);
 printf("\nGenerování DEKADICKÉHO čísla úspěšně dokončeno.\n");
}
/////////////////////////////////////////////////////////////
int main (void)
{
 cislo moc=1;
 moc=instro();
     bin(moc);
     hex(moc);
     dec(moc);
}
